package com.huimv.produce.timer;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.produce.entity.SysTelecom;
import com.huimv.produce.entity.SysTelecomEvent;
import com.huimv.produce.mapper.SysTelecomMapper;
import com.huimv.produce.service.ISysTelecomEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;


//主要用来生产烘干数据的 时间拿时间
@Component
public class SysTelcomEnentTimmer {
    //首先尝试存储数据进新表

    @Autowired
    private SysTelecomMapper  sysTelecomMapper;

    @Autowired
    private ISysTelecomEventService sysTelecomEventService;

       //每小时执行一次
       @Scheduled(cron = " 0 */59 * * * ?")
       private void updateBox() {
           //有好几个基站需要报警数据   现在默认是 fff15aea9c2a4b749efb68db751eaace   //这一台  后面还会加其他的参数吧
           //获得设备列表 查找烘干数据
           SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
           LambdaQueryWrapper<SysTelecom> lambdaQueryWrapper =
                   new LambdaQueryWrapper<>();
           lambdaQueryWrapper
                   .select(SysTelecom::getDeviceId);
           List<String> collect = sysTelecomMapper.selectObjs(lambdaQueryWrapper).stream().map(o -> (String) o).collect(Collectors.toList());
           for (String deviceId : collect) {
               Calendar c = Calendar.getInstance();
               c.setTime(new Date());
               c.add(Calendar.HOUR, -2);
               Date began1 = c.getTime();
               String startTime1 = format.format(new Date());
               String endTime1 = format.format(began1);
               LambdaQueryWrapper<SysTelecom> wrapper = Wrappers.lambdaQuery();
                   wrapper.eq(SysTelecom::getDeviceId, deviceId);
                   wrapper.eq(SysTelecom::getFarmId, 1);
                   wrapper.between(SysTelecom::getTimestamp, startTime1, endTime1);
               List<SysTelecom> sysTelecoms = sysTelecomMapper.selectList(wrapper);
               for (SysTelecom sysTelecom : sysTelecoms) {
                    if( Double.parseDouble(sysTelecom.getTemp())>50){
                        //产生时间段
                        Calendar c1 = Calendar.getInstance();
                        c1.setTime(sysTelecom.getTimestamp());
                        c1.add(Calendar.MINUTE, -60);
                        Date began = c.getTime();
                        String startTime = format.format(began);
                        c.add(Calendar.MINUTE, +110);
                        Date endTime11 = c.getTime();
                        String endTime = format.format(endTime11);
                        //查询在大于50摄氏度这条记录的 前60分钟 后60分钟  时间里，有没有存储过报警事件  有就放弃  没有就加一条
                        int count1 = sysTelecomEventService.count(Wrappers.<SysTelecomEvent>lambdaQuery()
                                .eq(SysTelecomEvent::getDeviceId,sysTelecom.getDeviceId())
                                .eq(SysTelecomEvent::getFarmId,sysTelecom.getFarmId())
                                .between(SysTelecomEvent::getEventTime, startTime, endTime));
                        if(count1==0){
                            SysTelecomEvent sysTelecomEvent = new SysTelecomEvent();
                            sysTelecomEvent.setDeviceId(sysTelecom.getDeviceId());
                            sysTelecomEvent.setEventTime(sysTelecom.getTimestamp());
                            sysTelecomEvent.setEventId(sysTelecom.getId());
                            sysTelecomEvent.setFarmId(sysTelecom.getFarmId());
                            sysTelecomEvent.setRemark(sysTelecom.getTemp());
                            sysTelecomEventService.save(sysTelecomEvent);
                        }
                        System.out.println("抛弃");
                    }
               }
           }
       }
}
